import 'dart:io';
import 'dart:ffi';
import 'dart:isolate';
import 'package:ffi/ffi.dart';

import 'package:libwinmedia/generated/bindings.dart';

var path =
    (Platform.script.path.split('/')..removeLast()).join('/').substring(1) +
        '/../libwinmedia.dll';
var lwm = LWM(DynamicLibrary.open(path));
var receiver = ReceivePort()
  ..listen(
    (message) {
      print(message);
    },
  );

void main(List<String> args) {
  var albumArt = '';
  lwm.InitializeDartApi(NativeApi.postCObject, receiver.sendPort.nativePort);
  lwm.NativeControlsCreate(Pointer.fromFunction(event));
  lwm.NativeControlsUpdate(
    1,
    ['album_artist', 'album', 'track_count', 'artist', 'title', 'track_number']
        .toNativeUtf16Array(),
    albumArt.toNativeUtf16(),
  );
}

void event(int button) {}

extension NativeTypesString on List<String> {
  Pointer<Pointer<Utf16>> toNativeUtf16Array() {
    final list =
        map((string) => string.toNativeUtf16()).toList().cast<Pointer<Utf16>>();
    final pointer = calloc.allocate<Pointer<Utf16>>(list.length * 8);
    for (var index = 0; index < length; index++) {
      pointer[index] = list[index];
    }
    return pointer;
  }
}

extension NativeTypesInt on List<int> {
  Pointer<Int32> toNativeArray() {
    final pointer = calloc.allocate<Int32>(length * 4);
    for (var index = 0; index < length; index++) {
      pointer[index] = this[index];
    }
    return pointer;
  }
}
