import 'dart:async';
import 'dart:ffi';
import 'dart:io';

import 'package:libwinmedia/libwinmedia.dart';

void main() {
  var path =
      (Platform.script.path.split('/')..removeLast()).join('/').substring(1) +
          '/libwinmedia.dll';
  LWM.initialize(DynamicLibrary.open(path));
  var player = Player(id: 0);
  player.streams.medias.listen((medias) {
    print('medias      : $medias.');
  });
  player.streams.isPlaying.listen((isPlaying) {
    print('isPlaying   : $isPlaying.');
  });
  player.streams.isBuffering.listen((isBuffering) {
    print('isBuffering : $isBuffering.');
    if (!isBuffering) {
      player.nativeControls.update(
        album: 'Fine Line',
        albumArtist: 'Harry Styles',
        trackCount: 12,
        artist: 'Harry Styles',
        title: 'Lights Up',
        trackNumber: 1,
        thumbnail: File('album_art.png'),
      );
    }
  });
  player.streams.isCompleted.listen((isCompleted) {
    print('isCompleted : $isCompleted.');
  });
  player.streams.position.listen((position) {
    print('position    :  $position.');
  });
  player.streams.duration.listen((duration) {
    print('duration    : $duration.');
  });
  player.streams.index.listen((index) {
    print('index       : $index.');
  });
  player.open([
    Media(
        uri:
            'https://p.scdn.co/mp3-preview/18f50618e8737c8a1f3b50a653023c5576af8955?cid=774b29d4f13844c495f206cafdad9c86'),
    Media(
        uri:
            'https://p.scdn.co/mp3-preview/669eef4c25c47eb54c8c0bceee55b94519f3b0c1?cid=774b29d4f13844c495f206cafdad9c86'),
  ]);
  player.play();
  Timer(Duration(days: 1), () {});
}
